#define PCF8574AP 0x70
#define PCF8574   0x40
#define E24Cxx    0xA0
#define PCF8583   0xA0


#define TWI_DEB 0

#define  TWINT  7
#define  TWEA	6
#define  TWSTA	5
#define  TWSTO	4
#define  TWWC	3
#define  TWEN	2
#define  TWIE	0  
#define  TW_WRITE 0
#define  TW_READ 1   

#define  TWGCE  1
// TWSR Werte
#define  TW_START     0x08
#define  TW_REPSTA    0x10
#define  TW_REP_START 0x10
#define  TW_MT_SLA_ACK   0x18
#define  TW_MT_SLA_NACK  0x20
#define  TW_MT_DATA_ACK  0x28
#define  TW_MT_DATA_NACK 0x30
#define  TW_NACK      0x38
#define  TW_MR_ARB_LOST  0x38
#define  TW_SLA_ACK   0x40
#define  TW_MR_SLA_ACK   0x40
#define  TW_SLA_NACK  0x48
#define  TW_MR_SLA_NACK  0x48
#define  TW_DATA_ACK  0x50
#define  TW_MR_DATA_ACK  0x50
#define  TW_DATA_NACK 0x58
#define  TW_MR_DATA_NACK 0x58
#define  TW_MT_ARB_LOST  0x38
//Master Receiver Mode Status Codes
#define  MR_START     0x08
#define  MR_REPSTA    0x10
#define  MR_ARB_LOST  0x38
#define  MR_SLA_ACK   0x40
#define  MR_SLA_NACK  0x48
#define  MR_DATA_ACK  0x50
#define  MR_DATA_NACK 0x58
//Master Transmitter Mode Status Codes
#define  MT_START     0x08
#define  MT_REPSTA    0x10
#define  MT_SLA_ACK   0x18
#define  MT_SLA_NACK  0x20
#define  MT_DATA_ACK  0x28
#define  MT_DATA_NACK 0x30
#define  MT_ARB_LOST  0x38


#define TWS_Start          1
#define TWS_Slave_Adr      2 
#define TWS_Rep_Start      3
#define TWS_Rep_Slave_Adr  4
#define TWS_send_Adr_High  6
#define TWS_send_Adr_Low   7
#define TWS_get_Data       10
#define TWS_put_Data       11

unsigned char TWI_sendStart();
void TWI_sendStop();
unsigned char TWI_SlaveAdrRW(unsigned char mainadr, unsigned char subadr, unsigned char RW);
unsigned char TWI_readByte(unsigned char TWEA01);                                           
unsigned char TWI_writeByte(unsigned char c);
void TWI_init(unsigned int freq);
unsigned char TWI_readACK(unsigned char mainadr, unsigned char subadr);
unsigned char TWI_readNACK(unsigned char mainadr, unsigned char subadr);
unsigned char TWI_write(unsigned char mainadr, unsigned char subadr, unsigned char c);
void TWI_Error(unsigned int nr, unsigned int TWI_ADR, unsigned int akt);
